import java.awt.event.*;
import java.awt.*;

/**
 * Manejador del Borrado de figuras
 */
class BorrarHandler implements ActionListener
{
   /**
    * Costructor de la clase
    * @param dib parantro de la case MiPanel
    */
   public BorrarHandler(MiPanel dib)
   {
      mipanel  = dib;
      indiceFig = INDICE_FIG;
   }
   
   /**
    * Metodo que captura el presionar del mouse sobre el menu borrar
    */
   public void actionPerformed(ActionEvent e)
   {
      mipanel.changeMouseListener(new MouseHandler());
      mipanel.removerIndices();
      mipanel.dibujarCuadrados();
      mipanel.removerSelector();      
   }
   
   /**
    * Clase interna que maneja los eventos del mouse
    * @author Mauricio Solis & Cesar Munoz
    */
   class MouseHandler extends MouseAdapter
   {
   /**
    * Metodo que captura la secuencia: 
    * mousePressed - mouseRelease en el mismo punto
    * es decir, un click del mouse
    */
   public void mouseClicked(MouseEvent event)
   {    
         Point p = event.getPoint();    
         indiceFig = mipanel.puntoPertenece(p);
         if (indiceFig >= 0)mipanel.remueva(indiceFig);
         mipanel.borrarCuadrados();
         mipanel.dibujarCuadrados();
         mipanel.repaint(); 
  }
   }

   private static final int INDICE_FIG = -2;
   private int indiceFig;
   private MiPanel mipanel;
}
