import java.awt.*;
//import java.awt.geom.*;

/**
 * Clase abstracta desde donde derivan
 * las formas que se incluiran en el programa
 */
public abstract class Forma 
{
   /**
    * Permite mostrar en pantalla las formas
    * @param g Variable Graphics2d
    */
   public abstract void paintComponent(Graphics2D g);
   
   /**
    * Permite cambiar el tamano en forma escalada
    * @param center Punto respecto al cual se realiza el escalamiento
    * @param factor factor del escalamiento
    */
   public abstract void escalar(Point center, double factor);
  
   /**
    * Permite rotar la figura respecto a algun punto
    * @param center Punto respecto al que se rotara la figura
    * @param deltaAngulo angulo de rotacion
    */
   public abstract void rotar(Point center, double deltaAngulo);
  
   /**
    * Permite trasladar la figura dentro de la ventana
    * @param deltaX desplazamiento en el eje x de la figura
    * @param deltaY desplazamiento en el eje y de la figura
    */
   public abstract void trasladar(double deltaX, double deltaY);
  
   /**
    * Devuelve el tipo de figura
    * @return Retorna un entero, que corresponde al tipo de figura actual
    */
   public abstract int getTipoFigura();
   
   /**
    * Metodo que permite obtener el punto con respecto al cual
    * se desea realizar la modificacion de la figura
    * @param vertice corresponde a un punto que pertenece a alguno
    * de los cuadritos de manipualcion
    * @return retorna el punto con respecto al cual se debe realizar
    * la modificacion
    */
   public abstract Point getRef(Point vertice);

}

