import java.awt.event.*;
import javax.swing.*;

/**
 * Clase que define el menu
 */
public class MiMenuBar extends JMenuBar
{ /**
    * Constructor del menu
    * @param mipanel ventan donde se dibujaran las figuras
    */
   public MiMenuBar (MiPanel mipanel)
   { JMenu menu = new JMenu("Crear Figura");
      menu.setMnemonic(KeyEvent.VK_C);
      menu.getAccessibleContext().setAccessibleDescription(
      "Permite incorporar nuevas formas a su dibujo");
      add(menu);
      JMenuItem menuItem = new JMenuItem("Linea", new
              ImageIcon("./images/line.gif"));
      menuItem.setMnemonic(KeyEvent.VK_L);
      menuItem.addActionListener(new CrearLineaHandler(mipanel));
      menu.add(menuItem); 
menuItem = new JMenuItem("Triangulo", new ImageIcon("./images/triangle.gif"));
      menuItem.setMnemonic(KeyEvent.VK_T);
      menuItem.addActionListener(new CrearTrianguloHandler(mipanel));
      menu.add(menuItem);      
      menuItem = new JMenuItem("Rectangulo", new
              ImageIcon("./images/rectangle.gif"));
      menuItem.setMnemonic(KeyEvent.VK_R);
      menuItem.addActionListener(new CrearRectanguloHandler(mipanel));
      menu.add(menuItem); 
      menuItem = new JMenuItem("Circulo", new ImageIcon("./images/circle.gif"));
      menuItem.setMnemonic(KeyEvent.VK_C);
      menuItem.addActionListener(new CrearCirculoHandler(mipanel));
      menu.add(menuItem);
      menu = new JMenu("Manipular Figura");
      menu.setMnemonic(KeyEvent.VK_M);
      menu.getAccessibleContext().setAccessibleDescription(
        "Permite hacer operaciones basicas sobre dibujo actual");
      add(menu);
      menuItem = new JMenuItem("Rotar", KeyEvent.VK_R);
      menuItem.addActionListener(new RotarHandler(mipanel));
      menu.add(menuItem);
      menuItem = new JMenuItem("Escalar", KeyEvent.VK_E);
      menuItem.addActionListener(new EscalarHandler(mipanel));
      menu.add(menuItem);
      menuItem = new JMenuItem("Trasladar", KeyEvent.VK_T);
      menuItem.addActionListener(new TrasladarHandler(mipanel));
      menu.add(menuItem);
      menuItem = new JMenuItem("Borrar", KeyEvent.VK_B);
      menuItem.addActionListener(new BorrarHandler(mipanel));
      menu.add(menuItem); } }

