import java.awt.event.*;
import javax.swing.*;
//import java.net.URL;

/**
 * Clase que define el la barra de menu applet
 * @author Mauricio Solis & Cesar Munoz
 */
public class MiMenuBarApplet extends JMenuBar
{   /**
    * Costructor del menu applet
    * @param dibujo Panel a dibujar
    * @param applet Apllet donde se dibujara
    */ 
   public MiMenuBarApplet (MiPanel dibujo, JApplet applet)
   {  JMenu menu = new JMenu("Dibujar");
      menu.setMnemonic(KeyEvent.VK_D);
      menu.getAccessibleContext().setAccessibleDescription(
      "Permite incorporar nuevas formas a su dibujo");
      add(menu);      
      JMenuItem menuItem = new JMenuItem("Linea", 
new ImageIcon(applet.getImage(applet.getCodeBase(), "./images/line.gif")));
      menuItem.setMnemonic(KeyEvent.VK_L);
      menuItem.addActionListener(new CrearLineaHandler(dibujo));
      menu.add(menuItem);      
      menuItem = new JMenuItem("Triangulo", 
new ImageIcon(applet.getImage(applet.getCodeBase(), "./images/triangle.gif")));
      menuItem.setMnemonic(KeyEvent.VK_T);
      menuItem.addActionListener(new CrearTrianguloHandler(dibujo));
      menu.add(menuItem);      
      menuItem = new JMenuItem("Rectangulo",
new ImageIcon(applet.getImage(applet.getCodeBase(), "images/rectangle.gif")));
      menuItem.setMnemonic(KeyEvent.VK_R);
      menuItem.addActionListener(new CrearRectanguloHandler(dibujo));
      menu.add(menuItem);      
      menuItem = new JMenuItem("Circulo",
new ImageIcon(applet.getImage(applet.getCodeBase(), "images/circle.gif")));
      menuItem.setMnemonic(KeyEvent.VK_C);
      menuItem.addActionListener(new CrearCirculoHandler(dibujo));
      menu.add(menuItem);     
      menu = new JMenu("Manipular"); menu.setMnemonic(KeyEvent.VK_M);
      menu.getAccessibleContext().setAccessibleDescription(
"Permite hacer operaciones basicas sobre dibujo actual"); add(menu);    
      menuItem = new JMenuItem("Escalar", KeyEvent.VK_E);
      menuItem.addActionListener(new EscalarHandler(dibujo));
      menu.add(menuItem);
      menuItem = new JMenuItem("Rotar", KeyEvent.VK_R);
      menuItem.addActionListener(new RotarHandler(dibujo));
      menu.add(menuItem);
      menuItem = new JMenuItem("Trasladar", KeyEvent.VK_T);
      menuItem.addActionListener(new TrasladarHandler(dibujo));
      menu.add(menuItem);
      menuItem = new JMenuItem("Borrar", KeyEvent.VK_B);
      menuItem.addActionListener(new BorrarHandler(dibujo));
      menu.add(menuItem); } }
